<template>
  <BasicDrawer v-bind="$attrs" @register="registerDrawer" showFooter :confirmDisabled="getConfirmDisabled" :title="getTitle" width="600px" @ok="handleSubmit">
    <a-spin :spinning="isLoading">
      <BasicForm @register="registerForm" />
    </a-spin>
  </BasicDrawer>
</template>
<script lang="ts" setup name="DistributorDrawer">
  import { defineEmits, ref, computed, unref } from 'vue';
  import { BasicForm, useForm } from '/@/components/Form/index';
  import { formSchema } from './schema';
  import { BasicDrawer, useDrawerInner } from '/@/components/Drawer';
  import { useAsyncState } from '@vueuse/core';
  import * as DistributorApi from '/@/api/system/distributorApi';
  import { Distributor } from '/@/api/model/distributor';

  const emit = defineEmits(['success', 'register']);
  const isUpdate = ref(true);
  const entityId = ref(0);

  const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
    labelWidth: 120,
    schemas: formSchema,
    showActionButtonGroup: false,
  });

  // id 查询
  const {
    state: detail,
    isReady: isDetailReady,
    isLoading,
    execute,
  } = useAsyncState(
          () => {
            return DistributorApi.getById(entityId.value).then((res: Distributor) => res);
          },
          null,
          {
            immediate: false,
          },
  );

  const [registerDrawer, { setDrawerProps, closeDrawer }] = useDrawerInner(async (data) => {
    await resetFields();
    setDrawerProps({ confirmLoading: false });
    isUpdate.value = !!data?.isUpdate;
    entityId.value = data?.record?.id;

    if (unref(isUpdate)) {
      await execute();
      if (detail.value) {
        const formData: any = {
          ...detail.value,
                };
        await setFieldsValue(formData);
      }
    }
  });

  const getConfirmDisabled = computed(() => {
    if (unref(isUpdate)) {
      return !unref(isDetailReady);
    } else {
      return false;
    }
  });

  const getTitle = computed(() => (!unref(isUpdate) ? '新增' : '编辑'));

  async function handleSubmit() {
    try {
      const values = await validate();
      setDrawerProps({ confirmLoading: true });
      const {
        ...rest
      } = values;
      const action = !unref(isUpdate) ? DistributorApi.add : DistributorApi.update;
      const data = !unref(isUpdate)
        ? {
            ...rest,
          }
        : Object.assign({},
          {
            ...rest,
            id: unref(entityId),
          },
        );
      await action(data);
      closeDrawer();
      emit('success');
    } finally {
      setDrawerProps({ confirmLoading: false });
    }
  }
</script>
